/*******************************************************************************
 *  Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp.  2001, 2006.  All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.ccl.mapping.xsd;

import java.util.List;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.ExtendedMetaData;

import com.ibm.ccl.mapping.xsd.util.XSDExtendedMetaDataImpl;

public interface XSDEcoreExtendedMetaData extends ExtendedMetaData
{
  public boolean isQualified(EStructuralFeature eFeature);
	
  /**
   * The default ExtendedMetaData instance, which obtains packages from the global package registry, {@link
   * org.eclipse.emf.ecore.EPackage.Registry#INSTANCE EPackage.Registry.INSTANCE}.
   */
  ExtendedMetaData INSTANCE = new XSDExtendedMetaDataImpl();

  /**
   * Provides the list with wildcards as available in the source schema.
   * @param eFeature the structural feature - must be a wildcard. 
   * @return a List with namespaces (##any, etc).
   */
  List getSourceWildcards(EStructuralFeature eFeature);
}
