/*******************************************************************************
 *  Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp.  2001, 2006.  All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.ccl.mapping.xsd.resources;

import org.eclipse.emf.ecore.resource.Resource.Factory;

/**
 * Default implementation of the {@link IXSDResourceProvider}.
 */
public abstract class BaseXSDResourceProvider implements IXSDResourceProvider
{
  /**
   * The file extension supported by the resource factory.
   */
  protected String fileExtension;

  /**
   * The file extension supported by the resource factory.
   */
  protected String name;

  /**
   * The resource factory instance.
   */
  protected Factory resourceFactory;

  /*
   * (non-Javadoc)
   * 
   * @see com.ibm.ccl.mapping.xsd.resources.IXSDResourceProvider#getFileExtension()
   */
  public String getFileExtension()
  {
    return fileExtension;
  }

  /*
   * (non-Javadoc)
   * 
   * @see com.ibm.ccl.mapping.xsd.resources.IXSDResourceProvider#getName()
   */
  public String getName()
  {
    return name;
  }

  /*
   * (non-Javadoc)
   * 
   * @see com.ibm.ccl.mapping.xsd.resources.IXSDResourceProvider#getResourceFactory()
   */
  public Factory getResourceFactory()
  {
    return resourceFactory;
  }
}
