/*******************************************************************************
 *  Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp.  2001, 2006.  All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.ccl.mapping.xsd.resources;

import java.util.Collection;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.Resource.Factory;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;

import com.ibm.ccl.mapping.internal.resources.DefaultMappingResources;
import com.ibm.ccl.mapping.xsd.resources.extension.XSDResourceProviderRegistry;

public class MappingResources extends DefaultMappingResources
{
  public ResourceSet getResourceSet(URI uri)
  {
    ResourceSet resourceSet = new ResourceSetImpl();

    // Use the extensions contributed to com.ibm.ccl.mapping.xsd.resourceProviders 
    // to contribute additional * -> XSD converters.
    
    Map extensionToFactoryMap = resourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap();

    XSDResourceProviderRegistry registry = XSDResourceProviderRegistry.getInstance();
    Collection descriptors = registry.getResourceProviders().values();

    Iterator iterator = descriptors.iterator();

    while (iterator.hasNext())
    {
      IXSDResourceProvider resourceProvider = (IXSDResourceProvider) iterator.next();

      String extension = resourceProvider.getFileExtension();
      Factory resourceFactory = resourceProvider.getResourceFactory();
      
      extensionToFactoryMap.put(extension, resourceFactory);
    }
    resourceSet.setURIConverter(getURIConverter());
    return resourceSet;
  }
}
