/*******************************************************************************
 *  Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp.  2001, 2006.  All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.ccl.mapping.xsd.resources;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.Method;
import java.util.Map;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.impl.ResourceImpl;
import org.eclipse.xsd.XSDSchema;
import org.eclipse.xsd.util.XSDResourceImpl;
import org.osgi.framework.Bundle;

public class XSDResourceForDTD extends ResourceImpl
{
	public XSDResourceForDTD(URI uri)
	{
		super(uri);
	}
	
  protected void doLoad(InputStream inputStream, Map options) throws IOException
  {
    try
    {
    	// TODO (cs) the DTDToXSD generator is a bit hairy
    	// we need to see if we can simplify this
    	//
    	InputStream xsdInputStream = null;
    	if (true)
    	{		    	
    		// We utilize a 'dynamic' approach to invoke the transformation
    		// as a cheap and dirty way of avoiding hard plugin dependencies.
    		//
    	  Bundle bundle = Platform.getBundle("com.ibm.xtt.gen.dtd.xsd");     //$NON-NLS-1$
    	  if (bundle == null)
    	  {
          throw new IOException("the com.ibm.xtt.gen.dtd.xsd plugin is required in order to work with DTD files");    	  	 //$NON-NLS-1$
    	  } 	
    	  Class clazz = bundle.loadClass("com.ibm.xtt.gen.dtd.xsd.internal.DTDToXSD"); //$NON-NLS-1$
    	  Class[] metaArgs = {String.class, OutputStream.class};
    	  Method method = clazz.getMethod("generate", metaArgs); //$NON-NLS-1$
    	  Object instance = clazz.newInstance();
    		ByteArrayOutputStream outputStream = new ByteArrayOutputStream();    	  
    	  Object[] args = { getURI().toString() , outputStream};
    	  method.invoke(instance, args);
        xsdInputStream = new ByteArrayInputStream(outputStream.toByteArray());  	  	    	   
    	}
    	/*
    	else
    	{		
    	  // Here's the 'static' version of the code above. This is povided to help understand 
    	  // the 'dynamic' code above and to enable debugging (by uncommenting).
    	  // Note that the plugin dependencies must be update in order to compile this code.
    	  //      		
    		DTDToXSD dtd2xsd = new DTDToXSD();
    		//dtd2xsd.setEncoding(encoding,encodingTag);
    		ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
    		dtd2xsd.generate(getURI().toString(), outputStream);
    		xsdInputStream = new ByteArrayInputStream(outputStream.toByteArray());      
    	}*/
    	if (xsdInputStream != null)
    	{
        XSDResourceImpl resourceImpl = new XSDResourceImpl(getURI());
        resourceImpl.load(xsdInputStream, null);
        XSDSchema schema = resourceImpl.getSchema();
        getContents().add(schema);    		
    	}		
    }
    catch (Exception e)
    {
    	e.printStackTrace();
      throw new IOException("can parse document :-("); //$NON-NLS-1$
    }
  }
}
