/*******************************************************************************
 *  Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp.  2001, 2006.  All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.ccl.mapping.xsd.resources;

import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Method;
import java.util.Map;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.impl.ResourceImpl;
import org.eclipse.xsd.XSDSchema;
import org.osgi.framework.Bundle;

public class XSDResourceForXML extends ResourceImpl
{
	public XSDResourceForXML(URI uri)
	{
		super(uri);
	}
	
  protected void doLoad(InputStream inputStream, Map options) throws IOException
  {
    try
    {
    	if (true)
    	{		    	
    		// We utilize a 'dynamic' approach to invoke the transformation
    		// as a cheap and dirty way of avoiding hard plugin dependencies.
    		//    		
    	  Bundle bundle = Platform.getBundle("com.ibm.xtt.gen.xml.xsd");     //$NON-NLS-1$
    	  if (bundle == null)
    	  {
          throw new IOException("the com.ibm.xtt.gen.xml.xsd plugin is required in order to work with XML instances");    	  	 //$NON-NLS-1$
    	  } 	
    	  Class clazz = bundle.loadClass("com.ibm.etools.xml.codegen.xsd.XSDGenerator"); //$NON-NLS-1$
    	  Class[] metaArgs = {InputStream.class};
    	  Method method = clazz.getMethod("generate", metaArgs); //$NON-NLS-1$
    	  Object instance = clazz.newInstance();
    	  Object[] args = { inputStream };
    	  Object o = method.invoke(instance, args);
    	  if (o instanceof XSDSchema)
    	  {
      		getContents().add((XSDSchema)o);    	  	
    	  } 	
    	}
    	/*
    	else
    	{	
    	  // Here's the 'static' version of the code above. This is povided to help understand 
    	  // the 'dynamic' code above and to enable debugging (by uncommenting).
    	  // Note that the plugin dependencies must be update in order to compile this code.
    	  //      	
    		XSDGenerator generator = new XSDGenerator();    	
    		XSDSchema schema = generator.generate(inputStream);
    		getContents().add(schema);
    	}*/
    }
    catch (Exception e)
    {
      throw new IOException("can parse document :-("); //$NON-NLS-1$
    }
  }
}
