/*******************************************************************************
 *  Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp.  2001, 2006.  All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.ccl.mapping.xsd.resources;

import org.eclipse.core.runtime.Platform;

/**
 * Provides a factory which infers XML schemas from a DTD document.
 */
public class XSDResourceProviderForDTD extends BaseXSDResourceProvider
{
  public XSDResourceProviderForDTD()
  {
    fileExtension = "dtd"; //$NON-NLS-1$
    name = "DTD"; //$NON-NLS-1$
    resourceFactory = new XSDResourceFactoryForDTD(); //$NON-NLS-1$
  }

  /*
   * (non-Javadoc)
   * 
   * @see com.ibm.ccl.mapping.xsd.resources.IXSDResourceProvider#isAvailable()
   */
  public boolean isAvailable()
  {
    return Platform.getBundle("com.ibm.xtt.gen.dtd.xsd") != null; //$NON-NLS-1$
  }

}
