/*******************************************************************************
 *  Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp.  2001, 2006.  All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.ccl.mapping.xsd.resources;

import org.eclipse.core.runtime.Platform;

/**
 * Provides a factory which infers XML schemas from an XML instance document.
 */
public class XSDResourceProviderForXML extends BaseXSDResourceProvider
{
  public XSDResourceProviderForXML()
  {
    fileExtension = "xml"; //$NON-NLS-1$
    name = "XML"; //$NON-NLS-1$
    resourceFactory = new XSDResourceFactoryForXML(); //$NON-NLS-1$
  }

  /*
   * (non-Javadoc)
   * 
   * @see com.ibm.ccl.mapping.xsd.resources.IXSDResourceProvider#isAvailable()
   */
  public boolean isAvailable()
  {
    return Platform.getBundle("com.ibm.xtt.gen.xml.xsd") != null; //$NON-NLS-1$
  }
}
