/*******************************************************************************
 *  Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp.  2001, 2006.  All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.ccl.mapping.xsd.util;

public class XSDEcoreConstants 
{
  public static final String MAP_FILE_EXTENSION = "map";         //$NON-NLS-1$
  public static final String XML_FILE_EXTENSION = "xml";         //$NON-NLS-1$
  public static final String XSD_FILE_EXTENSION = "xsd";         //$NON-NLS-1$
  public static final String XSL_FILE_EXTENSION = "xsl";         //$NON-NLS-1$
  public static final String WSDL_FILE_EXTENSION = "wsdl";       //$NON-NLS-1$
  public static final String DTD_FILE_EXTENSION = "dtd";         //$NON-NLS-1$

  public static final String AND_OTHERS = "_et_al";              //$NON-NLS-1$
  public static final String LANGUAGE_XPATH = "XPath";           //$NON-NLS-1$
  public static final String LANGUAGE_XSLT = "XSLT";             //$NON-NLS-1$
  public static final String TEST_SOURCE_SUFFIX = "-in";         //$NON-NLS-1$
  public static final String TEST_TARGET_SUFFIX = "-out";        //$NON-NLS-1$
  
  public static final String MAP_DEFAULT_BASE_TARGET_NAMESPACE = "http://www.example.org/";   //$NON-NLS-1$
  public static final String DOMAIN_ID = "com.ibm.ccl.mapping.codegen.xslt.domain";           //$NON-NLS-1$
  
  // reserved namespace names
  public static final String NS_URI_XMLNS = "http://www.w3.org/2000/xmlns/";                  //$NON-NLS-1$
  public static final String NS_URI_XML   = "http://www.w3.org/XML/1998/namespace";           //$NON-NLS-1$
  public static final String NS_URI_XSI   = "http://www.w3.org/2001/XMLSchema-instance";      //$NON-NLS-1$
  
  public static final String FUNCTION_CONCAT  = "concat";        //$NON-NLS-1$
  public static final String FUNCTION_SUBSTRING  = "substring";  //$NON-NLS-1$
  public static final String FUNCTION_NORMALIZE  = "normalize";  //$NON-NLS-1$
  public static final String FUNCTION_TRANSLATE  = "translate";  //$NON-NLS-1$
  public static final String FUNCTION_ASSIGN = "assign";         //$NON-NLS-1$
  
  /**
   * TypeInfo values of an EObject.
   * 
   * SIMPLE: contains data content only.
   * COMPLEX_WITH_STRUCTURED_CONTENT: contains structural content only.
   * COMPLEX_WITH_MIXED_CONTENT: contains data and structural content.
   */
  public final static int SIMPLE = 0;
  public final static int COMPLEX_WITH_SIMPLE_CONTENT = 1;
  public final static int COMPLEX_WITH_STRUCTURED_CONTENT = 2;
  public final static int COMPLEX_WITH_MIXED_CONTENT = 3;

}
